#define BQMAXIMO 0x08
#define BQ78350  0x0B
#define LOCAL_ADDRESS	0x4A

#define LOWBYTE(Data) (unsigned char)(0x00ff & Data)

#define HIGHBYTE(Data) (unsigned char)((0xff00 & Data)>>8)

#define CRC_KEY 7

#define DISABLE_INT asm(" BIC #8, SR")
#define ENABLE_INT	asm(" BIS #8, SR")
#define ENTER_LPM3  \
	WDTCTL = WDTPW + WDTHOLD; \
	asm(" BIS #0xD8, SR")
#define RESTORE_WATCHDOG   \
	WDTCTL = WDTPW + WDTSSEL;	\

#define WDT_START	WDTCTL = WDTPW + WDTSSEL
#define WDT_HOLD	WDTCTL = WDTPW + WDTHOLD
#define WDT_CLEAR	WDTCTL = WDTPW + WDTCNTCL + WDTSSEL

#define ENABLE_BOTTOM_BQ769x0	asm("  PUSH SR");\
	DISABLE_INT;\
	P4OUT |= BIT2;\
	P4OUT &= ~BIT6;\
	P4OUT &= ~BIT7;\
	asm("  POP SR");\
	Delay10mS()
//	Delay10mS();\
//	Delay10mS()

//#define SAVE_I2C_STATUS  asm("    PUSH P4OUT")
//#define RESTORE_I2C_STATUS asm("    POP P4OUT");
//		Delay10mS();\
//		Delay10mS();\
//		Delay10mS()

#define BOTTOM_BQ769x0_ENABLED	0x04

#define ENABLE_UPPER_BQ769x0	asm("  PUSH SR");\
	DISABLE_INT;\
	P4OUT &= ~BIT2;\
	P4OUT |= BIT6;\
	P4OUT |= BIT7;\
	asm("  POP SR");\
	Delay10mS()
//	Delay10mS();\
//	Delay10mS()

#define ENABLE_EXTERNAL_REFERENCE	P4OUT &= ~BIT3
#define DISABLE_EXTERNAL_REFERENCE	P4OUT |= BIT3
#define ENABLE_BAT_VOLT_DIVIDER		P4OUT |= BIT4
#define DISABLE_BAT_VOLT_DIVIDER	P4OUT &= ~BIT4
#define TURN_ON_DCDC				P4OUT |= BIT5
#define TURN_OFF_DCDC				P4OUT &= ~BIT5

#define UPPER_BQ769x0_ENABLED	0xC0

#define UART_TIMEOUT	3

#define TIMERA_INT_ENABLE TACTL |= TAIE

#define DELAY_LIMIT 0xffff

#define SYS_STAT 0
#define CELLBAL1 1
#define CELLBAL2 2
#define CELLBAL3 3
#define SYS_CTRL1 4
#define SYS_CTRL2 5
#define PROTECT1 0x06
#define PROTECT2 0x07
#define PROTECT3 0x08
#define OV_TRIP 0x09
#define UV_TRIP 0x0A
#define VC1_HI_BYTE 0x0C

#define ADCGAIN1 0x50
#define ADCOFFSET 0x51
#define ADCGAIN2 0x59

#define _CC_ONESHOT			0x20
#define _CC_READY			0x80
#define _DSG_ON				0x02
#define _CHG_ON				0x01
#define SCD_DELAY_50us		0x0
#define SCD_DELAY_100us		0x1
#define SCD_DEALY_200us		0x2
#define SCD_DELAY_400us		0x3

#define SCD_THRESH_44mV_22mV	0
#define SCD_THRESH_67mV_33mV	1
#define SCD_THRESH_89mV_44mV	2
#define SCD_THRESH_111mV_56mV	3
#define SCD_THRESH_133mV_67mV	4
#define SCD_TRHESH_155mV_68mV	5
#define SCD_THRESH_178mV_89mV	6
#define SCD_THRESH_200mV_100mV	7

#define OCD_DEALY_10ms		0x0
#define OCD_DELAY_20ms		0x1
#define OCD_DELAY_40ms		0x2
#define OCD_DELAY_80ms		0x3
#define OCD_DELAY_160ms		0x4
#define OCD_DELAY_320ms		0x5
#define OCD_DELAY_640ms		0x6
#define OCD_DELAY_1280ms	0x7

#define OCD_THRESH_17mV_8mV		0
#define OCD_THRESH_22mV_11mV	1
#define OCD_THRESH_28mV_14mV	2
#define OCD_THRESH_33mV_17mV	3
#define OCD_THRESH_39mV_19mV	4
#define OCD_THRESH_44mV_22mV	5
#define OCD_THRESH_50mV_25mV	6
#define OCD_THRESH_56mV_28MV	7
#define OCD_THRESH_61mV_31mV	8
#define OCD_THRESH_67mV_33mV	9
#define OCD_THRESH_72mV_36mV	0xA
#define OCD_THRESH_78mV_39mV	0xB
#define OCD_THRESH_83mV_42mV	0xC
#define OCD_THRESH_89mV_44mV	0xD
#define OCD_THRESH_94mV_47mV	0xE
#define OCD_THRESH_100mV_50mV	0xF

#define UV_DELAY_1s				0
#define UV_DELAY_4s				1
#define UV_DELAY_8s				2
#define UV_DELAY_16s			3

#define OV_DELAY_1s				0
#define OV_DELAY_2s				1
#define OV_DELAY_4s				2
#define OV_DELAY_8s				3

#define OV_THRESH_BASE			0x2008
#define UV_THRESH_BASE			0x1000
#define OV_STEP					0x10
#define UV_STEP					0x10

#define ADCGAIN_BASE			365

#define LOW_BYTE(Data)			(unsigned char)(0xff & Data)
#define HIGH_BYTE(Data)			(unsigned char)(0xff & (Data >> 8))
#define ENABLE_UART_SEND_INT	IE2 |= UCA0TXIE
#define DISABLE_UART_SEND_INT	IE2 &= ~UCA0TXIE

#define COMMAND_IDLE			0
#define COMMAND_RECEIVING		1
#define COMMAND_PROCESSING		2
#define NO_PENDING_COMMAND		0
#define READ					1
#define WRITE					2
#define EXECUTE					3
#define BUFFER_SIZE				33

#define FRAME_LENGTH_INDEX		0			//pointer to the position of the FrameLength

#define FRAME_RESPONSE_CHECKSUM_ERROR	0xFF
#define FRAME_RESPONSE_I2C_ERROR		0xFE
#define FRAME_RESPNOSE_UART_TIMEOUT		0xFD
#define FRAME_RESPONSE_AWAKENED	0xFC
#define FRAME_RESPONSE_OK				0x00

#define POWER_MODE_ACTIVE				0
#define POWER_MODE_SLEEP_ACTIVE			1
#define POWER_MODE_SLEEP				2
#define POWER_MODE_GOTO_SHUTDOWN		3

#define SLEEPTIMER_SEMAPHORE			0x80

#define BOTTOM_DEVICE					0
#define UPPER_DEVICE					1

//Error code definition
#define BIT_OPERATION_FAIL				-2
#define GENERAL_CALL_FAIL				-1

#define UPPER_DSG_FET_ON				1
#define UPPER_DSG_FET_OFF				2
#define UPPER_CHG_FET_ON				3
#define UPPER_CHG_FET_OFF				4
#define BOTTOM_DSG_FET_ON				5
#define BOTTOM_DSG_FET_OFF				6
#define BOTTOM_CHG_FET_ON				7
#define BOTTOM_CHG_FET_OFF				8

unsigned char CRC8(unsigned char *ptr, unsigned char len,unsigned char key);
int I2CWriteRegisterByteWithCRC(unsigned char I2CSlaveAddress, unsigned char Register, unsigned char Data);
int I2CReadRegisterWordWithCRC(unsigned char I2CSlaveAddress, unsigned char Register, unsigned int *Data);
int GetStatusRegister(unsigned char Device, unsigned char *Status);
int ClearStatusRegister(unsigned char Device, unsigned char Status);
bool CheckIfI2CEnabled(unsigned char Device);
int EnableDSG(unsigned char Device);
int DisableDSG(unsigned char Device);
int EnableCHG(unsigned char Device);
int DisableCHG(unsigned char Device);

typedef struct _Register_Group
{
	union
	{
		struct
		{
			unsigned char OCD			:1;
			unsigned char SCD			:1;
			unsigned char OV			:1;
			unsigned char UV			:1;
			unsigned char OVRD_ALERT	:1;
			unsigned char DEVICE_XREADY	:1;
			unsigned char WAKE			:1;
			unsigned char CC_READY		:1;
		}StatusBit;
		unsigned char StatusByte;
	}SysStatus;

	union
	{
		struct
		{
			unsigned char RSVD			:3;
			unsigned char CB5			:1;
			unsigned char CB4			:1;
			unsigned char CB3			:1;
			unsigned char CB2			:1;
			unsigned char CB1			:1;
		}CellBal1Bit;
		unsigned char CellBal1Byte;
	}CellBal1;

	union
	{
		struct
		{
			unsigned char RSVD			:3;
			unsigned char CB10			:1;
			unsigned char CB9			:1;
			unsigned char CB8			:1;
			unsigned char CB7			:1;
			unsigned char CB6			:1;
		}CellBal2Bit;
		unsigned char CellBal2Byte;
	}CellBal2;

	union
	{
		struct
		{
			unsigned char RSVD			:3;
			unsigned char CB15			:1;
			unsigned char CB14			:1;
			unsigned char CB13			:1;
			unsigned char CB12			:1;
			unsigned char CB11			:1;
		}CellBal3Bit;
		unsigned char CellBal3Byte;
	}CellBal3;

	union
	{
		struct
		{
			unsigned char SHUT_B		:1;
			unsigned char SHUT_A		:1;
			unsigned char RSVD1			:1;
			unsigned char TEMP_SEL		:1;
			unsigned char ADC_EN		:1;
			unsigned char RSVD2			:2;
			unsigned char LOAD_PRESENT	:1;
		}SysCtrl1Bit;
		unsigned char SysCtrl1Byte;
	}SysCtrl1;

	union
	{
		struct
		{
			unsigned char CHG_ON		:1;
			unsigned char DSG_ON		:1;
			unsigned char WAKE_T		:2;
			unsigned char WAKE_EN		:1;
			unsigned char CC_ONESHOT	:1;
			unsigned char CC_EN			:1;
			unsigned char DELAY_DIS		:1;
		}SysCtrl2Bit;
		unsigned char SysCtrl2Byte;
	}SysCtrl2;

	union
	{
		struct
		{
			unsigned char SCD_THRESH	:3;
			unsigned char SCD_DELAY		:2;
			unsigned char RSVD			:2;
			unsigned char RSNS			:1;
		}Protect1Bit;
		unsigned char Protect1Byte;
	}Protect1;

	union
	{
		struct
		{
			unsigned char OCD_THRESH	:4;
			unsigned char OCD_DELAY		:3;
			unsigned char RSVD			:1;
		}Protect2Bit;
		unsigned char Protect2Byte;
	}Protect2;

	union
	{
		struct
		{
			unsigned char RSVD			:4;
			unsigned char OV_DELAY		:2;
			unsigned char UV_DELAY		:2;
		}Protect3Bit;
		unsigned char Protect3Byte;
	}Protect3;

	unsigned char OVTrip;
	unsigned char UVTrip;
	unsigned char CCCfg;			//must be 0x19

	union
	{
		struct
		{
			unsigned char VC1_HI;
			unsigned char VC1_LO;
		}VCell1Byte;
		unsigned short VCell1Word;
	}VCell1;

	union
	{
		struct
		{
			unsigned char VC2_HI;
			unsigned char VC2_LO;
		}VCell2Byte;
		unsigned short VCell2Word;
	}VCell2;

	union
	{
		struct
		{
			unsigned char VC3_HI;
			unsigned char VC3_LO;
		}VCell3Byte;
		unsigned short VCell3Word;
	}VCell3;

	union
	{
		struct
		{
			unsigned char VC4_HI;
			unsigned char VC4_LO;
		}VCell4Byte;
		unsigned short VCell4Word;
	}VCell4;

	union
	{
		struct
		{
			unsigned char VC5_HI;
			unsigned char VC5_LO;
		}VCell5Byte;
		unsigned short VCell5Word;
	}VCell5;

	union
	{
		struct
		{
			unsigned char VC6_HI;
			unsigned char VC6_LO;
		}VCell6Byte;
		unsigned short VCell6Word;
	}VCell6;

	union
	{
		struct
		{
			unsigned char VC7_HI;
			unsigned char VC7_LO;
		}VCell7Byte;
		unsigned short VCell7Word;
	}VCell7;

	union
	{
		struct
		{
			unsigned char VC8_HI;
			unsigned char VC8_LO;
		}VCell8Byte;
		unsigned short VCell8Word;
	}VCell8;

	union
	{
		struct
		{
			unsigned char VC9_HI;
			unsigned char VC9_LO;
		}VCell9Byte;
		unsigned short VCell9Word;
	}VCell9;

	union
	{
		struct
		{
			unsigned char VC10_HI;
			unsigned char VC10_LO;
		}VCell10Byte;
		unsigned short VCell10Word;
	}VCell10;

	union
	{
		struct
		{
			unsigned char VC11_HI;
			unsigned char VC11_LO;
		}VCell11Byte;
		unsigned short VCell11Word;
	}VCell11;

	union
	{
		struct
		{
			unsigned char VC12_HI;
			unsigned char VC12_LO;
		}VCell12Byte;
		unsigned short VCell12Word;
	}VCell12;

	union
	{
		struct
		{
			unsigned char VC13_HI;
			unsigned char VC13_LO;
		}VCell13Byte;
		unsigned short VCell13Word;
	}VCell13;

	union
	{
		struct
		{
			unsigned char VC14_HI;
			unsigned char VC14_LO;
		}VCell14Byte;
		unsigned short VCell14Word;
	}VCell14;

	union
	{
		struct
		{
			unsigned char VC15_HI;
			unsigned char VC15_LO;
		}VCell15Byte;
		unsigned short VCell15Word;
	}VCell15;

	union
	{
		struct
		{
			unsigned char BAT_HI;
			unsigned char BAT_LO;
		}VBatByte;
		unsigned short VBatWord;
	}VBat;

	union
	{
		struct
		{
			unsigned char TS1_HI;
			unsigned char TS1_LO;
		}TS1Byte;
		unsigned short TS1Word;
	}TS1;

	union
	{
		struct
		{
			unsigned char TS2_HI;
			unsigned char TS2_LO;
		}TS2Byte;
		unsigned short TS2Word;
	}TS2;

	union
	{
		struct
		{
			unsigned char TS3_HI;
			unsigned char TS3_LO;
		}TS3Byte;
		unsigned short TS3Word;
	}TS3;

	union
	{
		struct
		{
			unsigned char CC_HI;
			unsigned char CC_LO;
		}CCByte;
		unsigned short CCWord;
	}CC;

	union
	{
		struct
		{
			unsigned char RSVD1			:2;
			unsigned char ADCGAIN_4_3	:2;
			unsigned char RSVD2			:4;
		}ADCGain1Bit;
		unsigned char ADCGain1Byte;
	}ADCGain1;

	unsigned char ADCOffset;

	union
	{
		struct
		{
			unsigned char RSVD			:5;
			unsigned char ADCGAIN_2_0	:3;
		}ADCGain2Bit;
		unsigned char ADCGain2Byte;
	}ADCGain2;

}RegisterGroup;

typedef struct _Command_Frame
{
    unsigned char Operation_Type;
    unsigned char CommandLength;
	union
	{
		unsigned char *CommandData;
		struct
		{
			unsigned char *CommandData;
			unsigned char ReadDataLength;
			unsigned char *ReadData;
		}ReadCommandBody;
	}CommandBody;
}CommandFrame;
